/*  file: datindex.c
 *
 *  CfNX^p
 *
 *  $Id: datindex.c,v 1.11 2001/09/08 19:53:54 2ch Exp $ */

#include <assert.h>
#include <ctype.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/mman.h>
#include "datindex.h"
#include "read.h"

#ifdef USE_INDEX

/* /board/dat/idx/XXXXXXXXXX.idx */
#define DATINDEX_PATH "dat/idx"

/* version  0 ̂Ƃ́A蒼(sec) */
#define DATINDEX_EXPIRATION 60

/****************************************************************
 *	t͂
 *	͂ɐAXLԂ
 *	s 0 Ԃ
 *	cȂb̎擾ɂΉĂ邼(
 ****************************************************************/
static int get_date(struct tm *datetime,
		    char const *p)
{
	char buf[24];
	char const *dp;
	int n, ofs, yy;

	memset(datetime, 0, sizeof(struct tm));

	ofs = strcspn(p, "<>\n0123456789");
	if (!isdigit(p[ofs]))
	return 0;

	/* yymmdd𓾂 */
	n = strspn(&p[ofs], "/0123456789");
	if (n >= 20)
		return 0;
	memcpy(buf, &p[ofs], n);
	buf[n] = 0;
	ofs += n;
	if (!(dp = strtok(buf, "/")))
		return 0;
	yy = atoi(dp);
	if (yy >= 1900)
		yy -= 1900;
	else if (yy < 70)
		yy += 100;
	datetime->tm_year = yy;
	if (!(dp = strtok(NULL, "/")))
		return 0;
	datetime->tm_mon = atoi(dp) - 1;
	if (!(dp = strtok(NULL, "/")))
		return 0;
	datetime->tm_mday = atoi(dp);

	/* hhmm[ss]𓾂 */
	ofs += strcspn(&p[ofs], "<>\n0123456789");
	if (!isdigit(p[ofs]))
		return 0;
	n = strspn(&p[ofs], ":0123456789");
	if (n >= 20)
		return 0;
	memcpy(buf, &p[ofs], n);
	buf[n] = 0;
	ofs += n;
	if (!(dp = strtok(buf, ":")))
		return 0;
	datetime->tm_hour = atoi(dp);
	if (!(dp = strtok(NULL, ":")))
		return 0;
	datetime->tm_min = atoi(dp);
	if ((dp = strtok(NULL, ":")) != NULL)
		datetime->tm_sec = atoi(dp);

	return ofs;
}
/****************************************************************
 *	w肳ꂽs(chunkȓ)
 *	sCfNX肠
 *	shared_idxȂ
 *	i񂾃ItZbgԂ
 ****************************************************************/
static int buildup_line(struct DATINDEX_LINE *line,
			int line_n,
			char const *dat,
			int datlen,
			time_t dat_lastmod,
			int *valid_lines,
			time_t *newest_lastmod)
{
	int ofs;
	int linenum;

	/* ܂ epoch n߂ */
	*newest_lastmod = 0;

	for (ofs = 0, linenum = 0;
	     ofs < datlen && linenum < line_n;
	     line++, linenum++) {
		int i, n;
		int orig_ofs;
		struct tm datetime;

		/* 킩ȂtOĂ߂ */
		int aborted = 0;	/* ځ[? */
		int completed = 0;	/* p[XʂZbgׂ */
		time_t lastmod = dat_lastmod;

		orig_ofs = ofs;

		/* name<>mailto<>date id<>text<>[subject]\n */
		/* name, mailtoXLbv */
		for (i = 0; i < 2; i++) {
			if (i == 0)
				line->name.p = &dat[ofs];
			else if (i == 1)
				line->mailto.p = &dat[ofs];

			while (!(dat[ofs] == '<' && dat[ofs + 1] == '>')) {
				if (dat[ofs] == '\n') {
					ofs++;
					goto can_not_parse;
				}
				ofs++;
				ofs += strcspn(&dat[ofs], "<>\n");
			}

			if (i == 0)
				line->name.len = &dat[ofs] - line->name.p;
			else if (i == 1)
				line->mailto.len = &dat[ofs] - line->mailto.p;

			ofs += 2;
		}

		/* t͂
		   t܂ȂA
		   ځ[ƌȂ */
		n = get_date(&datetime, &dat[ofs]);
		if (n == 0) {
			/* ځ[ƌȂ
			   ̂܂܍s̏ł؂Ă̂
			   X^Cg擾ꍇ̂ŁA
			   ̏ꍇ̓tO𗧂Ăđs(T */
			aborted = 1;
		} else {
			/* 擾 L-M ƂăZbgĂ */
			lastmod = mktime(&datetime);
		}
		/* date̎cA{XLbv */
		for (i = 0; i < 2; i++) {
			if (i == 0)
				line->date.p = &dat[ofs];
			else if (i == 1)
				line->text.p = &dat[ofs];

			while (!(dat[ofs] == '<' && dat[ofs + 1] == '>')) {
				if (dat[ofs] == '\n') {
					ofs++;
					goto can_not_parse;
				}
				ofs++;
				ofs += strcspn(&dat[ofs], "<>\n");
			}

			if (i == 0)
				line->date.len = &dat[ofs] - line->mailto.p;
			else if (i == 1)
				line->text.len = &dat[ofs] - line->date.p;

			ofs += 2;
		}
		/* ܂ŗꂽ炠ځ[ł͂ȂƌȂ
		   ( aborted ZbgĂꍇ )*/
		if (!aborted) {
			completed = 1;
		}
		/* X^Cg邩ȂAǂݔ΂ */

	can_not_parse:
		/* XXX t@CI[̃Pcj\
		   C!! */
		ofs += 1 + strcspn(&dat[ofs], "\n");

		if (completed) {
			line->lastmod = lastmod;
		} else {
			/* s̉͂ĂȂꍇ */

			static struct DATINDEX_LINE ab =
			{
				{"ځ[", 8},
				{"ځ[", 8},
				{"ځ[", 8},
				{"ځ[", 8},
				0, 0
			};

			*line = ab;
		}

		line->len = ofs - orig_ofs;	/* \n ܂ł̒ */

		/* ځ[słƂ́A
		   lastmod ŐV̂܂܂ł͂ */
		if (*newest_lastmod < lastmod)
			*newest_lastmod = lastmod;
	}

	*valid_lines = linenum;
	return ofs;
}
/****************************************************************
 *	pӂꂽ̈
 *	VɃCfNX肠
 *	private_datɃt@Cǂ܂Ă̂O
 *	͏sȂ
 *	idx  NULL ^邱ƂŁA
 *	sCfNX̂ݍXVłB
 *	ŏIsԂ
 ****************************************************************/
static int buildup_index(DATINDEX_OBJ *dat,
			 int linenum,	/* 0 origin */
			 DATINDEX volatile *idx,
			 long ofs,
			 long datlen)
{
	int chunk;
	char const *const p = dat->private_dat;
	int n_line_processed;

	/* .dat  mtime ͋L^Ă */
	if (idx)
		idx->lastmod = dat->dat_stat.st_mtime;

	chunk = linenum / DATINDEX_CHUNK_SIZE;
	linenum %= DATINDEX_CHUNK_SIZE;

	for (;
	     (ofs < datlen
	      && (DATINDEX_CHUNK_SIZE * chunk + linenum
		  < DATINDEX_MAX_ARTICLES));
	     linenum += n_line_processed,
		     (linenum >= DATINDEX_CHUNK_SIZE
		      ? chunk++, linenum = 0
		      : 0)) {
		struct DATINDEX_LINE *line;
		int i, n;

		time_t chunk_lastmod;

		n = DATINDEX_CHUNK_SIZE * chunk + linenum;
		line = &dat->line[n];

		/* sCfNX𐶐 */
		ofs += buildup_line(line,
				    DATINDEX_CHUNK_SIZE - linenum,
				    &p[ofs],
				    datlen - ofs,
				    dat->dat_stat.st_mtime,
				    &n_line_processed,
				    &chunk_lastmod);
		if (!idx)
			continue;

		/* ȍ~Aidx̍XVɓ */

		if (linenum == 0
		    && n_line_processed == DATINDEX_CHUNK_SIZE) {
			/* chunkSɑĂȂ
			   CfNX͍XVȂ */
			idx->idx[chunk].lastmod = chunk_lastmod;
			idx->idx[chunk].nextofs = ofs;

			/* Lȍsɑ΂ătOĂĂ */
			for (i = 0; i < n_line_processed; i++) {
				if (line[i].lastmod)
					idx->idx[chunk].valid_bitmap |= 1 << i;
			}
		}

		/* TuWFNĝĂÂ */
		if (n == 0
		    && line->len
		    && memcmp(&line->text.p[line->text.len],
			      "<>",
			      2) == 0)
			idx->title_ofs = (line->text.p
					  - line->name.p
					  + line->text.len + 2);
	}

	/* linenum  CHUNK_SIZE 𒴂Ăꍇ邪A
	   L͓̎K؂ɓB */
	linenum = DATINDEX_CHUNK_SIZE * chunk + linenum;
	
	if (idx)
		idx->linenum = linenum;

	return linenum;
}
/****************************************************************
 *	q[vɗ̈mۂACfNXݏグ
 *	sȂ
 *	͍쐬INDEXԂƂɒ
 ****************************************************************/
static DATINDEX *create_local_index(DATINDEX_OBJ *dat)
{
	DATINDEX *idx = calloc(1, sizeof(DATINDEX));
	if (!idx)
		return 0;
	dat->shared_idx = idx;
	if (buildup_index(dat,
			  0,	/* Jns */
			  idx,
			  0,	/* t@CItZbg */
			  dat->dat_stat.st_size)) {
		dat->linenum = idx->linenum;
		return idx;
	} else
		return NULL;
}
/****************************************************************
 *	CfNXt@C쐬Ă݂
 *	쐬łȂƂ̓[Jɍ
 ****************************************************************/
static int create_index(DATINDEX_OBJ *dat,
			char const *fn)
{
	int fd;
	DATINDEX *tidx;

	/* ܂A[JɃCfNXĂ݂
	   datetB[h́A[Je
	   ̂ŁÂ܂܋AĂȂȂB */
	tidx = create_local_index(dat);
	if (!tidx) {
		/* .datt@CsƂ݂Ȃ */
		return 0;
	}

	fd = open(fn, O_CREAT | O_EXCL | O_RDWR, 0666);
	if (fd < 0) {
		/* Ƃ΁AidxfBNg
		   ݂ȂꍇłAopen(2)
		   sBCfNX̓[Jɍ쐬 */
		return 1;	/* [JCfNXċA */
	}

	/* t@C̈o
	   쐬Ă private idx o*/
	if (write(fd, tidx, sizeof(DATINDEX)) < 0) {
		/* XXX {Ȃ unlink  */
		return 0;
	}
	/* ̂Amap */
	dat->shared_idx = mmap(NULL,
			       sizeof(DATINDEX),
			       PROT_READ | PROT_WRITE,
			       MAP_SHARED,
			       fd,
			       0);
	if (dat->shared_idx == MAP_FAILED) {
		return 0;
	}

	/* ŌɁAȂǂ */
	dat->shared_idx->signature = DATINDEX_VERSION;
	dat->shared_idx->version   = DATINDEX_VERSION;

	return 1;
}
/****************************************************************
 *	{.dat
 *	Œł邩ǂ킵Ă݂
 *	܂BigBuffer̂Ƃ͍lĂȂ
 *	.datJW[́AꂾłB
 ****************************************************************/
static int open_dat(DATINDEX_OBJ *dat,
		    char const *bs, long ky)
{
	int fd;
	char fn[64];

	/* sCfNXȀԂō쐬 */
	dat->line = calloc(sizeof(dat->line[0]),
			   DATINDEX_MAX_ARTICLES);
	if (!dat->line)
		return 0;

	sprintf(fn, "../%.64s/dat/%ld.dat", bs, ky);
	fd = open(fn, O_RDONLY);
	if (fd < 0)
		return 0;
	if (fstat(fd, &dat->dat_stat) < 0)
		return 0;
	dat->private_dat = mmap(NULL,
				dat->dat_stat.st_size + 1,
				PROT_READ,
				MAP_PRIVATE,
				fd,
				0);
	if (dat->private_dat == MAP_FAILED)
		return 0;

	/* ƂƂɂĂ
	    fd ̌n̓T{ XXX */

	return 1;
}
/****************************************************************
 *	CfNXt@CɌŒ肷
 *	ŒłȂƂ́AG[Ԃ
 ****************************************************************/
int datindex_open(DATINDEX_OBJ *dat,
		  char const *bs, long ky)
{
	int fd;
	int ver;
	int local_ofs, local_st, current_n, old_n;
	int i;

	char fn[64];

	/* ܂͖{.dat
	   Œł邩ǂ킵Ă݂
	   ܂BigBuffer̂Ƃ͍lĂȂ */
	if (!open_dat(dat, bs, ky))
		return 0;

	/* idx ̃t@CnhI[v */
	sprintf(fn, "../%.64s/" DATINDEX_PATH "/%ld.idx", bs, ky);
	fd = open(fn, O_RDWR);
	if (fd < 0) {
		/* CfNX쐬
		   (ƃ[J
		   邩Ȃ) */
		return create_index(dat, fn);
	}

	/* ܂ map 󂯂 */
	dat->shared_idx = mmap(NULL,
			       sizeof(DATINDEX),
			       PROT_READ | PROT_WRITE,
			       MAP_SHARED,
			       fd,
			       0);
	if (dat->shared_idx == MAP_FAILED) {
		/* ͂ŃCfNX */
		return !!create_local_index(dat);
	}

	/* CfNX̃o[W */
	ver = dat->shared_idx->version;
	if (ver == 0) {
		/* v莞ԂoĂȂ? */
		struct stat idx_stat;
		if (fstat(fd, &idx_stat) >= 0
		    && time(NULL) >= idx_stat.st_mtime + DATINDEX_EXPIRATION
		    && unlink(fn) >= 0) {
			/* ܂莞ԂoȃćA
			   葹˂ƍlA
			   Ǎ쐬݂ */
			return create_index(dat, fn);
		}

		/* ͂ŃCfNX */
		return !!create_local_index(dat);
	} else if (ver > DATINDEX_VERSION) {
		/* m̃o[WȂ̂ŋQ */
		return !!create_local_index(dat);
	} else if (ver < DATINDEX_VERSION
		   || dat->shared_idx->signature != DATINDEX_VERSION) {
		/* ׂč蒼 */
		if (unlink(fn) >= 0)
			return create_index(dat, fn);
	}

	/* ׂĂ
	   炪zg̓
	   ܂́ACfNXɑȂ
	   sCfNX([J)Ƃ */

	/* łɗpӂĂCfNXv */
	local_ofs = 0;
	for (i = 0; 
	     i < DATINDEX_IDX_SIZE
		     && dat->shared_idx->idx[i].nextofs != 0;
	     i++)
		local_ofs = dat->shared_idx->idx[i].nextofs;

	local_st = DATINDEX_CHUNK_SIZE * i;

	/* ɁA[JsCfNX(s)\z */
	dat->linenum = buildup_index(dat,
				     local_st,
				     NULL,
				     local_ofs,
				     dat->dat_stat.st_size);
	/* XVsȂꍇ͉邱ƂȂA͂ */
	if (!dat->linenum)
		return 1;

	/* indexXVׂǂ̔f */
	current_n = dat->shared_idx->linenum;
	if (current_n >= dat->linenum)
		return 1;

	/* i񂾕\ */
	old_n = DATINDEX_CMPXCHG(dat->shared_idx->linenum,
				 current_n,
				 dat->linenum);

	/* \ʂȂA߂ċA */
	if (old_n == dat->linenum)
		return 1;

	/* chunk boundary܂łȂAKviV */
	if (old_n / DATINDEX_CHUNK_SIZE
	    == dat->linenum / DATINDEX_CHUNK_SIZE)
		return 1;

	/* \ʂāAAchunk boundary
	   ܂Achunk indexXV`𕉂 */
	for (i = old_n / DATINDEX_CHUNK_SIZE;
	     i < dat->linenum / DATINDEX_CHUNK_SIZE;
	     i++) {
		int j;
		dat->shared_idx->idx[i].lastmod = 0;
		for (j = 0; j < DATINDEX_CHUNK_SIZE; j++)
			if (dat->line[DATINDEX_CHUNK_SIZE * i + j].lastmod)
				dat->shared_idx->idx[i].valid_bitmap |= 1 << j;
	}

	return 1;
}

/****************************************************************
 *	lastmodEグ
 *	first ́A!is_nofirst() ł邱Ƃɒ
 *	^p[^́A1 originzB
 ****************************************************************/
time_t datindex_lastmod(DATINDEX_OBJ const *dat,
			int first,	/* 1Ԗڂ܂߂ */
			int st,
			int to)
{
	int i;
	int st_chunk = (st - 1) / DATINDEX_CHUNK_SIZE;
	time_t lastmod = 0;

	for (i = (first ? 0 : st_chunk);
	     i <= (to - 1) / DATINDEX_CHUNK_SIZE;
	     (i == 0 && st_chunk > 0
	      ? i = st_chunk
	      : i++)) {
		if (dat->shared_idx->idx[i].nextofs == 0) {
			if (lastmod < dat->dat_stat.st_mtime)
				lastmod = dat->dat_stat.st_mtime;
		} else if (lastmod < dat->shared_idx->idx[i].lastmod)
			lastmod = dat->shared_idx->idx[i].lastmod;
	}
	return lastmod;
}
#endif /* USE_INDEX */
/*EOF*/
